package com.beitian.plugin.mp3;

import android.content.Context;
import android.media.MediaPlayer;
import android.net.Uri;
import android.util.Log;

import com.getcapacitor.JSObject;
import com.getcapacitor.Plugin;
import com.getcapacitor.PluginCall;
import com.getcapacitor.PluginMethod;
import com.getcapacitor.annotation.CapacitorPlugin;

@CapacitorPlugin(name = "PluginMp3")
public class PluginMp3Plugin extends Plugin {

    private PluginMp3 implementation = new PluginMp3();
    private MusicPlayer player;

    @PluginMethod
    public void echo(PluginCall call) {
        Log.e("++dcw", "PluginMp3Plugin::echo >> 4444444");
        String value = call.getString("value");

        JSObject ret = new JSObject();
        ret.put("value", implementation.echo(value));
        call.resolve(ret);
    }

    @PluginMethod()
    public void playMp3(PluginCall call) {
        Log.e("++dcw", "PluginMp3Plugin::playMp3 >> start play");
        player = new MusicPlayer(this.getContext());
        player.start();
        call.resolve();
    }

    @PluginMethod()
    public void stopMp3(PluginCall call) {
        Log.e("++dcw", "PluginMp3Plugin::stopMp3 >> stop play");
        if (player != null) {
            player.stop();
            player = null;
        }
        call.resolve();
    }

    public class MusicPlayer {
        private static final String MP3_URL = "https://file.kuyinyun.com/group1/M00/90/B7/rBBGdFPXJNeAM-nhABeMElAM6bY151.mp3";
        private MediaPlayer mPlayer;
        private Context mContext;

        public MusicPlayer(Context context) {
            mContext = context;
            init();
        }

        private void init() {
            Uri uri = Uri.parse(MP3_URL);
            mPlayer = MediaPlayer.create(mContext, uri);
        }

        public void start() {
            mPlayer.start();
        }

        public void stop() {
            mPlayer.stop();
        }
    }
}
